<template>
    <q-page class="bg-base">
        <Container>
            <DocumentWrapper ref="wrap">
                <div v-if="activeRules.length === 0">
                    <AnimationComponent text="There are currently no rules in this floor. Add one?"
                                        :animation="$animations.emptyBox"
                                        :max-height="1"/>
                </div>
                <ListPage class="relative-position" v-else>
                    <q-list bordered separator>
                        <ActiveRuleItem v-for="(activeRule, i) in activeRules" :active-rule="activeRule" :key="i" @subscribe="Subscribe" @remove="loadRules"/>
                    </q-list>
                </ListPage>
                <q-dialog persistent v-model="dialog">
                    <div class="bg-base q-pa-lg">
                        <AddRuleDialog :registered="activeRules" @submit="Submit" @back="dialog = false"/>
                    </div>
                </q-dialog>
            </DocumentWrapper>
            <q-btn round size='lg' color="accent" icon="add" class="absolute-bottom-right q-ma-lg"
                   @click="dialog=true">
                <q-tooltip anchor="center left" self="center right">
                    Add a rule to this floor
                </q-tooltip>
            </q-btn>
        </Container>
    </q-page>


</template>

<style lang='scss' scoped>

</style>

<script lang='ts'>
import {Component, Vue} from 'vue-property-decorator';
import DocumentWrapper from "components/Core/DocumentWrapper.vue";
import ListPage from "components/Core/ListPage.vue";
import {ActiveRuleResponse} from "src/classLibrary/APIModels/core/activeRuleResponse";
import AnimationComponent from "components/Core/AnimationComponent.vue";
import AddRuleDialog from "components/Dialog/AddRuleDialog.vue";
import Container from "components/Core/Container.vue";
import ActiveRuleItem from "components/Entities/List/ActiveRuleItem.vue";
import {Option} from "@hqoss/monads";
import {ApiError} from "src/classLibrary/Core/Api";

@Component({
    components: {ActiveRuleItem, Container, AddRuleDialog, AnimationComponent, ListPage, DocumentWrapper}
})
export default class FloorRules extends Vue {
    activeRules: ActiveRuleResponse[] = [];

    dialog = false;
    routeParams = {
        floorId: '',
    }

    async Subscribe(a: ActiveRuleResponse, sub: boolean) {
        const p = this;
        const token = await this.$auth.CoreToken;
        let r: Option<ApiError>;
        if (sub) {
            r = await this.$coreApi.QPost(`ActiveRule/subscribe?userId=${this.$coreAuth.user?.principal.id}&id=${a.id}`, null, token)
        } else {
            r = await this.$coreApi.QPost(`ActiveRule/unsubscribe?userId=${this.$coreAuth.user?.principal.id}&id=${a.id}`, null, token)
        }
        r.match({
            none: () => {
                p.loadRules();
            },
            some: (e) => {
                console.error(e);
                p.$q.notify({
                    icon: 'warning',
                    color: 'negative',
                    message: `Failed to subscribe to ${a.rule.name}`
                })
            }
        })
    }

    Submit() {
        this.dialog = false;
        this.init();
    }

    get Wrap(): DocumentWrapper {
        return this.$refs.wrap as any;
    }

    async loadRules() {
        const p = this;
        const token = await this.$auth.CoreToken;
        const r = await this.$coreApi.Get<ActiveRuleResponse[]>(`ActiveRule/floor/${this.routeParams.floorId}`
            , null, token);

        r.match({
            err: (e) => p.Wrap.SubmitError(e),
            ok: (o) => {
                p.activeRules = o;

            }
        })
    }

    async init() {
        await this.loadRules();
    }


}
</script>
